local insert,ipairs = table.insert, ipairs;

_Avyr_Global_ADDON_Elements_Lib.TextureParent = _Avyr_Global_ADDON_Elements_Lib.TextureParent or CreateFrame("Frame")
local function Release(self)
    self:ClearTheme()
    self:SetVertexColor(1,1,1,1)
    self:SetTexCoord(0,1,0,1)
    self:SetGradientAlpha("VERTICAL", 1,1,1,1 ,1,1,1,1)
    self:SetTexture(nil)
    self:SetParent(_Avyr_Global_ADDON_Elements_Lib.TextureParent)
    self:Hide()
    self:SetDesaturated(false)
    self:ClearAllPoints()
    self.Released = true
end

local function ClearTheme(self)
    self.ColorThemeAlignment = nil
    self.SecondaryColorTheme = nil
    self.PrimaryMulti = nil 
    self.SecondaryMulti = nil 
    self.PrimaryAlpha = nil
    self.SecondaryAlpha = nil
end 

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:FetchTexture(Parent, Layer, Level)
    local Texture
    for i, v in ipairs(_Avyr_Global_ADDON_Elements_Lib.Textures) do
        if v.Released then
        Texture = v
        end
    end

    if not Texture then
        Texture = _Avyr_Global_ADDON_Elements_Lib.TextureParent:CreateTexture(nil, Layer or "ARTWORK")
        insert(_Avyr_Global_ADDON_Elements_Lib.Textures,Texture)
        Texture.Release = Release
        Texture.ClearTheme = ClearTheme
    end

    Texture.Released = false
    Texture:SetDrawLayer(Layer or "ARTWORK", Level or 0)
    Texture:ClearAllPoints()
    Texture:SetParent(Parent or _Avyr_Global_ADDON_Elements_Lib.TextureParent)
    Texture:Show()

    return Texture
end

